Index: rtp.c
===================================================================
--- rtp.c	(revision 10761)
+++ rtp.c	(working copy)
@@ -108,6 +108,7 @@
 	unsigned int flags;
 	struct sockaddr_in us;		/*!< Socket representation of the local endpoint. */
 	struct sockaddr_in them;	/*!< Socket representation of the remote endpoint. */
+	struct sockaddr_in defaultthem;	/*!< Socket representation of the remote endpoint. */
 	struct timeval rxcore;
 	struct timeval txcore;
 	struct timeval dtmfmute;
@@ -1102,8 +1103,12 @@
 
 void ast_rtp_set_peer(struct ast_rtp *rtp, struct sockaddr_in *them)
 {
-	rtp->them.sin_port = them->sin_port;
-	rtp->them.sin_addr = them->sin_addr;
+	/* Nothing changed - don't change NATed address */
+	if (rtp->nat && (rtp->defaultthem.sin_port == them->sin_port) &&
+	    (rtp->defaultthem.sin_addr.s_addr == them->sin_addr.s_addr))
+		return;
+	rtp->them.sin_port = rtp->defaultthem.sin_port = them->sin_port;
+	rtp->them.sin_addr = rtp->defaultthem.sin_addr = them->sin_addr;
 	if (rtp->rtcp) {
 		rtp->rtcp->them.sin_port = htons(ntohs(them->sin_port) + 1);
 		rtp->rtcp->them.sin_addr = them->sin_addr;
